EDIT - bug #9142

The Agent search dialog shows duplicated entries
07/10/2020 04:43 PM - Andreas Mdller

Status: Closed Start date:

Priority: New Due date:

Assignee: Katja Luther % Done: 90%
Category: taxeditor Estimated time: 0:00 hour
Target version: Release 5.19

Severity: normal Found in Version:

Description

This happens in caryo_spp.

Things like this sometimes happen due multiple language representations of a term which is used in the underlying query. There is a
workaround for this.

But there might be other reasons.
WGB:
Im Bulk-Editor erscheint das Team nur einmal, und die IDs deuten ja auch darauf hin, dass hier etwas faul ist.

Associated revisions

Revision 359b77dd - 12/17/2020 11:35 AM - Katja Luther

fix #9142: fix doubled entries in agent selection dialog

Revision f0cf9026 - 12/18/2020 10:50 AM - Katja Luther
ref #9142: fix getUuidAndAbbrevTitleCache for agents

Revision 84e04ed3 - 12/18/2020 11:24 AM - Katja Luther
ref #9142: use clazz for FROM statement in getUuidAndAbbrevTitleCache for agents

Revision 3133b77d - 01/21/2021 04:13 PM - Andreas Miiller

ref #9142 code simplification

Revision ¢955d553 - 01/22/2021 12:16 PM - Katja Luther
ref #9142: code cleaning

History

#1 - 07/10/2020 04:45 PM - Andreas Miuller
- Description updated

#2 - 12/04/2020 09:03 AM - Katja Luther

- Target version changed from Release 5.18 to Release 5.19

#3 - 12/17/2020 11:30 AM - Katja Luther
- Status changed from New to Resolved

- Assignee changed from Katja Luther to Andreas Mdiller

This should be fixed. Please review.

#4 - 12/17/2020 11:36 AM - Katja Luther
- % Done changed from 0 to 50

Applied in changeset taxeditor|359b77dda6efc328563cfd93e63aee841662bde?.

#5 - 12/17/2020 11:39 AM - Andreas Miiller

can you shortly explain what the problem was and why the commit fixes it?

#6 - 12/17/2020 11:49 AM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Muiller to Katja Luther

#7 - 12/18/2020 10:54 AM - Katja Luther
- Status changed from Feedback to Resolved

- Assignee changed from Katja Luther to Andreas Miiller

First | thought it was because the search method was called twice but the real cause was the wrong implementation of the
getUuidAndAbbrevTitleCache method.

#8 - 12/18/2020 11:14 AM - Andreas Miiller
- Status changed from Resolved to Feedback

- Assignee changed from Andreas Miiller to Katja Luther

Thats what | thought. It is actually not really a wrong implementation of the method but due to the above described strange behavior of hibernate
when using eager loading.

By the way can't we remove the commented line?

Also | wonder if not the more correct way to filter for classes is to use the class parameter in HQL as described here (
https://docs.jboss.org/hibernate/orm/3.5/reference/de-DE/html/queryhqal.html#queryhgl-where) or here (
https://stackoverflow.com/questions/8911894/hql-query-for-multiple-types-classes). | guess this way you can also use abstract superclasses like
TeamOrPersonBase and do not have to distinguish each case. The current implementation is dangerous whenever the might be a new AgentBase
subclass in future and probably does even now not work if you pass "AgenBase.class" as parameter which is a legal argument.

#9 - 12/18/2020 11:25 AM - Katja Luther

- Assignee changed from Katja Luther to Andreas Mdiller

Andreas Muller wrote:

Thats what | thought. It is actually not really a wrong implementation of the method but due to the above described strange behavior of hibernate
when using eager loading.

By the way can't we remove the commented line?

Also | wonder if not the more correct way to filter for classes is to use the class parameter in HQL as described here (
https://docs.jboss.org/hibernate/orm/3.5/reference/de-DE/html/queryhqgl.html#queryhql-where) or here (
https://stackoverflow.com/questions/8911894/hql-query-for-multiple-types-classes). | guess this way you can also use abstract superclasses like
TeamOrPersonBase and do not have to distinguish each case. The current implementation is dangerous whenever the might be a new
AgentBase subclass in future and probably does even now not work if you pass "AgenBase.class" as parameter which is a legal argument.
| already thought about it, but thought that TeamOrPersonBase would not work, but it work. | changed the implementation in this way, please have a
look.

#10 - 01/21/2021 04:37 PM - Andreas Miiller

Katja Luther wrote:
Andreas Muller wrote:

Thats what | thought. It is actually not really a wrong implementation of the method but due to the above described strange behavior of
hibernate when using eager loading.

By the way can't we remove the commented line?

Also | wonder if not the more correct way to filter for classes is to use the class parameter in HQL as described here (
https://docs.jboss.org/hibernate/orm/3.5/reference/de-DE/html/queryhgl.html#queryhgl-where) or here (
https://stackoverflow.com/questions/8911894/hql-query-for-multiple-types-classes). | guess this way you can also use abstract superclasses
like TeamOrPersonBase and do not have to distinguish each case. The current implementation is dangerous whenever the might be a new
AgentBase subclass in future and probably does even now not work if you pass "AgenBase.class" as parameter which is a legal argument.

| already thought about it, but thought that TeamOrPersonBase would not work, but it work. | changed the implementation in this way, please
have a look.

| cleaned up the query code a bit further to make it simpler.

#11 - 01/21/2021 06:04 PM - Andreas Miiller
- Assignee changed from Andreas Mtiller to Katja Luther

- % Done changed from 50 to 90
Andreas Muller wrote:

By the way can't we remove the commented line?

| deleted the line and also cleaned up the TaxEditor code further.
There is still the commented code for "createFilter()" starting at line 110. Can this be removed?

The ticket can be closed then.

#12 - 01/22/2021 12:16 PM - Katja Luther
- Status changed from Feedback to Closed

cleaned the code and close ticket.
